package java.util.function;

import java.util.Objects;

@FunctionalInterface
public interface Predicate<T>
{
    public abstract boolean test(T p0);
    
    default public Predicate<T> and(Predicate<? super T> obj) {
        Objects.requireNonNull(obj);
        return o/* java.lang.Object, */ -> this.test(o) && p0.test(o);
    }
    
    default public Predicate<T> negate() {
        return o/* java.lang.Object, */ -> !this.test(o);
    }
    
    default public Predicate<T> or(Predicate<? super T> obj) {
        Objects.requireNonNull(obj);
        return o/* java.lang.Object, */ -> this.test(o) || p0.test(o);
    }
    
    public static <T> Predicate<T> isEqual(Object o) {
        return (null == o) ? Objects::isNull : (obj/* java.lang.Object, */ -> p0.equals(obj));
    }
}
